#if (!defined(KCL_INCLUDED))

#define KCL_INCLUDED	1

////////////////////////////////////////////////////////////////

typedef int KCL_Int32;
typedef unsigned int KCL_UInt32;
typedef void *KCL_Obj;
#define KCL_AlignMalloc		16	// x86̏ꍇ: 32bit[hł8, 64bit[hł16
	// ܂16łAقǑ傫Ȗɂ͂ȂȂ.

void KCL_error(const char *fmt, ...);

////////////////////////////////////////////////////////////////

typedef struct KCL_PtrStack_ {
	KCL_Obj *top;
} KCL_PtrStack;

void KCL_PtrStack_init(KCL_PtrStack *stack);
#define KCL_PtrStack_free	KCL_dummyFree
KCL_Obj KCL_PtrStack_pull(KCL_PtrStack *stack);
KCL_Obj KCL_PtrStack_push(KCL_PtrStack *stack, KCL_Obj obj);
void KCL_PtrStack_pushArray(KCL_PtrStack *stack, void *obj, int size, int n);

////////////////////////////////////////////////////////////////

typedef struct KCL_PtrPool_ {
	KCL_PtrStack stack;
	int sizeObj;
	int sizeAlloc;
	int extendParam; // 1-256
	void *a;
} KCL_PtrPool;

void KCL_PtrPool_init(KCL_PtrPool *pool, int sizeObj, int sizeAlloc, int extendParam);
void KCL_PtrPool_free(KCL_PtrPool *pool);
KCL_Obj KCL_PtrPool_pull(KCL_PtrPool *pool);
KCL_Obj KCL_PtrPool_push(KCL_PtrPool *pool, KCL_Obj obj);

////////////////////////////////////////////////////////////////

typedef struct KCL_Malloc_ {
	KCL_PtrPool pool0008;
	KCL_PtrPool pool0016;
	KCL_PtrPool pool0064;
//	KCL_PtrPool pool0256;
//	KCL_PtrPool pool1024;
//	KCL_PtrPool pool4096;
} KCL_Malloc;

void KCL_Malloc_init(KCL_Malloc *mpool);
void KCL_Malloc_free(KCL_Malloc *mpool);
KCL_Obj KCL_Malloc_alc(KCL_Malloc *mpool, int siz);
void KCL_Malloc_fre(KCL_Malloc *mpool, KCL_Obj obj, int siz);

#endif

