#include "kcl.h"

void KCL_PtrStack_init(KCL_PtrStack *stack)
{
	stack->top = 0;
	return;
}

KCL_Obj KCL_PtrStack_pull(KCL_PtrStack *stack)
{
	KCL_Obj obj = stack->top;
	if (obj != 0)
		stack->top = *((KCL_Obj *) obj);
	return obj;
}

KCL_Obj KCL_PtrStack_push(KCL_PtrStack *stack, KCL_Obj obj)
{
	*((KCL_Obj *) obj) = stack->top;
	stack->top = obj;
	return obj;
}

void KCL_PtrStack_pushArray(KCL_PtrStack *stack, void *obj, int size, int n)
{
	char *p = obj;
	p += size * n;
	while (n > 0) {
		p -= size;
		KCL_PtrStack_push(stack, p);
		n--;
	}
	return;
}

